OUT = "cleaned_output_pertarget.txt"
IN = "shadows_pertarget.txt"
class Elemento(object):
    
    def __init__(self, archivo, linea, contenido):
        self.archivo = archivo
        self.linea = linea
        self.contenido = contenido
        
    def __hash__(self):
        return hash(self.archivo) ^ hash(self.linea)

    def __cmp__(self, obj):
        if obj.archivo == self.archivo and self.linea == obj.linea:
            return True
        return False

    def __eq__(self, obj):
        if obj.archivo == self.archivo and self.linea == obj.linea:
            return True
        return False
    
        
def extract(src, elementos, set):
    for line in src.readlines():
        line = line.split(";")
        set.add(Elemento(line[0],line[1],line[2]))
    for element in set:
        if not elementos.has_key(element.archivo):
            elementos[element.archivo] = [element]
        else:
            elementos[element.archivo].append(element)

if __name__ == "__main__":
    elementos = {}
    src = open(IN,'r')
    extract(src, elementos, set())
    for j in elementos.itervalues():
        for i in j:
            print i.archivo +";"+i.linea+";"+i.contenido[:-1]
