package certrevsim;

import joinpointinterfaces.*;

public class DeltaRevocationInfo extends RevocationInfo{
	
	<R> exhibits R Execution() :
		(execution(R.new (..))
		|| execution(* *(..)))
	    && !cflow(withincode(* lawOfDemeter..*(..)));

	//pertarget
	<R> exhibits R Set(R value) :
		set(* *) && argsinv(value);

	

  // double thisUpdate double nextUpdate double id;
  double baseId;

  public DeltaRevocationInfo(double id, double baseId, 
			     double thisUpdate, double nextUpdate,
			     double deltaDegree,double revocationValidityPeriod){
    super(id, thisUpdate, nextUpdate, deltaDegree, revocationValidityPeriod);
    this.baseId = baseId;
  }

  public double getBaseId(){
    return baseId;
  }
}
