package lawOfDemeter.objectform;

import lawOfDemeter.AnyAspect;

import certrevsim.*;
import certrevsim.Simulator.*;
import jsim.queue.*;
import jsim.event.*;
import java.io.PrintStream;
import java.lang.*;


import java.text.*;
import joinpointinterfaces.*;

/**
 * @authors David H. Lorenz and Pengcheng Wu
 * @version 0.8, 12/19/02
 */
/*** THIS MUST BE LINE 9 ***/
aspect Percflow extends ObjectSupplier 
  percflow(AnyAspect.Execution()|| AnyAspect.Initialization()){
	
  before Execution(){
      addValue(thisJoinPoint.getThis());
      addAll(thisJoinPoint.getArgs());	  
  }
  
  <R> after Call() returning (R result){
      addValue(result);	  
  }
}


